mod Mtextm

rem 
  \para \bf  Turing Machines.  \end 

rem 
  \para \bf  Auxiliary functions and predicates.  \end 

appldisp/2 Tex_f2_tm_char_nef
  Infix(Arg(0),24,0,Subsup(Op('',Ent('NotEqual'),0),75,Op('*',0),None),Arg(1))

appldisp/2 Tex_f2_tm_pp_tuplef
  Prefix(100,2,Subsup(Id(0,'Tuple',0),75,Op('*',0),None),
         Fenced(Op('(',0),Infix(Arg(0),30,2,Op(',',0),Arg(1)),Op(')',0)))

appldisp/1 Tex_f1_tm_nb_sz
  Fenced(Op(Ent('mid'),0),Arg(0),Op(Ent('mid'),0))

appldisp/2 Tex_f2_tm_nb_conc
  Infix(Arg(0),40,1,Op(Ent('sstarf'),0),Arg(1))

rem 
  \para \bf  Definition of Turing machines.  \end 

rem 
  \para \it  General.  \end 

appldisp/0 Tex_f0_tm_a
  Id(1,'A',0)

appldisp/0 Tex_f0_tm_ar
  Id(1,'ARITY',0)

appldisp/1 Tex_f1_tm_cf
  Prefix(100,2,Fenced(Op(Ent('lang'),0),Id(1,'f',0),Op(Ent('rang'),0)),Arg(0))

rem 
  \para \it  Tape symbols.  \end 

appldisp/0 Tex_f0_tm_sb
  Id(2,'0',0)

appldisp/0 Tex_f0_tm_so
  Id(2,'1',0)

appldisp/0 Tex_p0_tm_ts
  Id(0,Ent('Sigma'),0)

appldisp/1 Tex_p1_tm_ts
  Infix(Arg(0),40,0,Op(Ent('isin'),0),Id(0,Ent('Sigma'),0))

appldisp/1 Tex_f1_tm_mkones
  Subsup(Id(2,'1',0),75,None,Arg(0))

rem 
  \para \it  Internal states.  \end 

appldisp/0 Tex_f0_tm_qb
  Id(1,'BEGIN',0)

appldisp/0 Tex_f0_tm_qe
  Id(1,'END',0)

appldisp/0 Tex_p0_tm_q
  Id(0,'Q',0)

appldisp/1 Tex_p1_tm_q
  Infix(Arg(0),40,0,Op(Ent('isin'),0),Id(0,'Q',0))

rem 
  \para \it  Movement.  \end 

appldisp/0 Tex_f0_tm_dh
  Op(Ent('dArr'),0)

appldisp/0 Tex_f0_tm_dl
  Op(Ent('lArr'),0)

appldisp/0 Tex_f0_tm_dr
  Op(Ent('rArr'),0)

appldisp/0 Tex_p0_tm_fd
  Id(0,Ent('Delta'),0)

appldisp/1 Tex_p1_tm_fd
  Infix(Arg(0),40,0,Op(Ent('isin'),0),Id(0,Ent('Delta'),0))

rem 
  \para \it  Input/output.  \end 

appldisp/2 Tex_f2_tm_enc1
  Std('Enc1',0)

appldisp/2 Tex_f2_tm_enc
  Std('Enc',0)

appldisp/1 Tex_f1_tm_dc1
  Std('Dc1',0)

appldisp/1 Tex_f1_tm_dc
  Std('Dc',0)

rem 
  \para \it  Computation.  \end 

appldisp/2 Tex_f2_tm_tf
  Std('m',0)

appldisp/1 Tex_f1_tm_run
  Std('M',0)

appldisp/1 Tex_f1_tm_urun
  Prefix(100,2,Subsup(Id(1,'M',0),75,None,Op('*',0)),Arg(0))

rem 
  \para \it  Debugging.  \end 

appldisp/2 Tex_f2_tm_brun
  Std('Brun',0)

appldisp/2 Tex_f2_tm_debug
  Std('Debug',0)

rem 
  \para \bf  Some Turing computable functions.  \end 

appldisp/1 Tex_f1_tm_rec_ss
  Std('S',0)

appldisp/1 Tex_f1_tm_rec_pred
  Infix(Arg(0),40,1,Op(Ent('minusd'),0),Num('1',0))

appldisp/2 Tex_f2_tm_rec_i_2_1
  Prefix(100,2,Subsup(Id(1,'I',0),100,Num('1',0),Num('2',0)),
         Fenced(Op('(',0),Infix(Arg(0),30,2,Op(',',0),Arg(1)),Op(')',0)))

appldisp/2 Tex_f2_tm_rec_i_2_2
  Prefix(100,2,Subsup(Id(1,'I',0),100,Num('2',0),Num('2',0)),
         Fenced(Op('(',0),Infix(Arg(0),30,2,Op(',',0),Arg(1)),Op(')',0)))

appldisp/1 Tex_f1_tm_rec_twice
  Infix(Num('2',0),45,1,Op(Ent('sdot'),0),Arg(0))

rem 
  \para \bf  Arithmetization of Turing machines.  \end 

rem 
  \para \it  Computation.  \end 

appldisp/3 Tex_f3_tm_tf
  Prefix(100,2,Subsup(Id(1,'m',0),75,Arg(0),None),
         Fenced(Op('(',0),Infix(Arg(1),30,2,Op(',',0),Arg(2)),Op(')',0)))

appldisp/2 Tex_f2_tm_run
  Prefix(100,2,Subsup(Id(1,'M',0),75,Arg(0),None),Arg(1))

appldisp/3 Tex_f3_tm_irun
  Prefix(100,2,Subsup(Id(1,'M',0),75,Arg(1),Arg(0)),Arg(2))

rem 
  \para \it  Kleene's T-predicates.  \end 

appldisp/2 Tex_p2_tm_asymp
  Infix(Arg(0),25,0,Op(Ent('sime'),0),Arg(1))

appldisp/2 Tex_f2_tm_rec_mr_mu
  Prefix(100,2,Prefix(50,2,Id(0,Ent('mu'),0),Arg(0)),
         Fenced(Op('[',0),Arg(1),Op(']',0)))

appldisp/4 Tex_p4_tm_ct1
  Infix(Arg(0),25,0,Op(Ent('Vdash'),0),
        Infix(Prefix(100,2,Subsup(Id(0,Ent('phi'),0),75,Arg(1),None),Arg(2)),25,0,
              Op(Ent('sime'),0),Arg(3)))

appldisp/4 Tex_p5_tm_ct1_1
  Infix(Arg(0),25,0,Op(Ent('Vdash'),0),
        Infix(Prefix(100,2,
                     Subsup(Id(0,Ent('phi'),0),75,Arg(1),
                            Fenced(Op('(',0),Num('1',0),Op(')',0))),Arg(2)),25,0,
              Op(Ent('sime'),0),Arg(3)))

appldisp/5 Tex_p5_tm_ct2
  Infix(Arg(0),25,0,Op(Ent('Vdash'),0),
        Infix(Prefix(100,2,Subsup(Id(0,Ent('phi'),0),75,Arg(1),None),
                     Fenced(Op('(',0),Infix(Arg(2),30,2,Op(',',0),Arg(3)),Op(')',0))),
              25,0,Op(Ent('sime'),0),Arg(4)))

appldisp/5 Tex_p5_tm_ct2_2
  Infix(Arg(0),25,0,Op(Ent('Vdash'),0),
        Infix(Prefix(100,2,
                     Subsup(Id(0,Ent('phi'),0),75,Arg(1),
                            Fenced(Op('(',0),Num('2',0),Op(')',0))),
                     Fenced(Op('(',0),Infix(Arg(2),30,2,Op(',',0),Arg(3)),Op(')',0))),
              25,0,Op(Ent('sime'),0),Arg(4)))

appldisp/6 Tex_p6_tm_ct3
  Infix(Arg(0),25,0,Op(Ent('Vdash'),0),
        Infix(Prefix(100,2,Subsup(Id(0,Ent('phi'),0),75,Arg(1),None),
                     Fenced(Op('(',0),
                            Infix(Arg(2),30,2,Op(',',0),
                                  Infix(Arg(3),30,2,Op(',',0),Arg(4))),Op(')',0))),
              25,0,Op(Ent('sime'),0),Arg(5)))

appldisp/6 Tex_p6_tm_ct3_3
  Infix(Arg(0),25,0,Op(Ent('Vdash'),0),
        Infix(Prefix(100,2,
                     Subsup(Id(0,Ent('phi'),0),75,Arg(1),
                            Fenced(Op('(',0),Num('3',0),Op(')',0))),
                     Fenced(Op('(',0),
                            Infix(Arg(2),30,2,Op(',',0),
                                  Infix(Arg(3),30,2,Op(',',0),Arg(4))),Op(')',0))),
              25,0,Op(Ent('sime'),0),Arg(5)))

rem 
  \para \it  Enumeration.  \end 

appldisp/2 Tex_f2_tm_comp_enum1
  Prefix(100,2,Subsup(Id(0,Ent('phi'),0),75,Arg(0),None),Arg(1))

appldisp/2 Tex_f2_tm_comp_enum1_1
  Prefix(100,2,
         Subsup(Id(0,Ent('phi'),0),75,Arg(0),Fenced(Op('(',0),Num('1',0),Op(')',0))),
         Arg(1))

appldisp/3 Tex_f3_tm_comp_enum2
  Prefix(100,2,Subsup(Id(0,Ent('phi'),0),75,Arg(0),None),
         Fenced(Op('(',0),Infix(Arg(1),30,2,Op(',',0),Arg(2)),Op(')',0)))

appldisp/3 Tex_f3_tm_comp_enum2_2
  Prefix(100,2,
         Subsup(Id(0,Ent('phi'),0),75,Arg(0),Fenced(Op('(',0),Num('2',0),Op(')',0))),
         Fenced(Op('(',0),Infix(Arg(1),30,2,Op(',',0),Arg(2)),Op(')',0)))

appldisp/4 Tex_f4_tm_comp_enum3
  Prefix(100,2,Subsup(Id(0,Ent('phi'),0),75,Arg(0),None),
         Fenced(Op('(',0),
                Infix(Arg(1),30,2,Op(',',0),Infix(Arg(2),30,2,Op(',',0),Arg(3))),
                Op(')',0)))

appldisp/4 Tex_f4_tm_comp_enum3_3
  Prefix(100,2,
         Subsup(Id(0,Ent('phi'),0),75,Arg(0),Fenced(Op('(',0),Num('3',0),Op(')',0))),
         Fenced(Op('(',0),
                Infix(Arg(1),30,2,Op(',',0),Infix(Arg(2),30,2,Op(',',0),Arg(3))),
                Op(')',0)))

rem 
  \para \it  Turing indices.  \end 

appldisp/0 Tex_f0_tm_xs
  Id(3,'S',0)

appldisp/0 Tex_f0_tm_xz
  Id(3,'Z',0)

appldisp/0 Tex_f0_tm_xpred
  Id(3,'Pred',0)

appldisp/0 Tex_f0_tm_xi_2_1
  Subsup(Id(3,'I',0),75,Num('1',0),Num('2',0))

appldisp/0 Tex_f0_tm_xi_2_2
  Subsup(Id(3,'I',0),75,Num('2',0),Num('2',0))

appldisp/0 Tex_f0_tm_xplus
  Id(3,'Plus',0)

appldisp/0 Tex_f0_tm_xtwice
  Id(3,'Twice',0)

