mod Mtm

incl Mtex

incl Mtextm

incl Maux

rem 
  \para \bf  Turing Machines.  \end 

rem 
  \para \bf  Tape symbols.  \end The tape alphabet \ft Tex_p0_tm_ts \end 
  consists of two symbols: the blank symbol \ft Tex_f0_tm_sb \end and the symbol 
  \ft Tex_f0_tm_so \end. 

fun/0 Sb 'Tex_f0_tm_sb'
  Sb = 0

fun/0 So 'Tex_f0_tm_so'
  So = 1

rem 
  \para The predicate \ft Tex_p1_tm_ts(s) \end holding of tape symbols is 
  defined explicitly as a primitive recursive predicate: 

pred Ts 'Tex_p1_tm_ts'
  Ts(s) <-> s = Sb \/ s = So

rem 
  \para Strings of \ft So \end 's. 

pred Ones 
  Ones(0)
  Ones S1(w) <- Ones(w)

fun Mkones 'Tex_f1_tm_mkones'
  Mkones(0) = 0
  Mkones(x+1) = S1 Mkones(x)

rem 
  \para \bf  Internal states.  \end The set of internal states of a Turing 
  machine contains at least two different states. These ate the initial state 
  \ft Tex_f0_tm_qb \end and the final state \ft Tex_f0_tm_qe \end of the 
  machine. 

fun/0 Qb 'Tex_f0_tm_qb'
  Qb = 1

fun/0 Qe 'Tex_f0_tm_qe'
  Qe = 0

rem 
  \para \bf  Movement.  \end Only the following movement may be performed by the 
  head of a Turing machine: 
  \items 
   \item \para the head stays at the same square - this is represented by the 
         number \ft Tex_f0_tm_dh \end, 
   \item \para the head moves one square left - this is represented by the 
         number \ft Tex_f0_tm_dl \end, 
   \item \para the head moves one square right - this is represented by the 
         number \ft Tex_f0_tm_dr \end. 
  \end

fun/0 Dh 'Tex_f0_tm_dh'
  Dh = 0

fun/0 Dl 'Tex_f0_tm_dl'
  Dl = 1

fun/0 Dr 'Tex_f0_tm_dr'
  Dr = 2

rem 
  \para The predicate \ft Tex_p1_tm_fd(d) \end which holds if \ft d \end is one 
  of the above possible movements is defined explicitly as a primitive recursive 
  predicate: 

pred Fd 'Tex_p1_tm_fd'
  Fd(d) <-> d = Dh \/ d = Dl \/ d = Dr

rem 
  \para \bf  Displays of configurations.  \end The primitive recursive predicate 
  \ft Fc \end is the cartesian format and it can be used to control the display 
  of the configurations of Turing machines. The configurations are numbers of 
  the form \ft q,l,r \end, where \ft q \end is an internal state, \ft l \end is 
  a left word, and \ft r \end is a right word. 

pred Fc 
  Fc(q,l,r) <- N(q) & Nb(l) & Nb(r)

